/*----- PROTECTED REGION ID(OceanOpticsClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        OceanOpticsClass.h
//
// description : Include for the OceanOptics root class.
//               This class is the singleton class for
//                the OceanOptics device class.
//               It contains all properties and methods which the 
//               OceanOptics requires only once e.g. the commands.
//
// project :     SolarLaserSystems S100
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: graziano $
//
// $Revision: 1.9 $
// $Date: 2019-04-23 11:16:11 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef OceanOpticsClass_H
#define OceanOpticsClass_H

#include <tango.h>
#include <OceanOptics.h>

/*----- PROTECTED REGION END -----*/	//	OceanOpticsClass.h


namespace OceanOptics_ns
{
/*----- PROTECTED REGION ID(OceanOpticsClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	OceanOpticsClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute ExposureTime class definition
class ExposureTimeAttrib: public Tango::Attr
{
public:
	ExposureTimeAttrib():Attr("ExposureTime",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ExposureTimeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_ExposureTime(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_ExposureTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_ExposureTime_allowed(ty);}
};

//	Attribute IncrSensitivity class definition
class IncrSensitivityAttrib: public Tango::Attr
{
public:
	IncrSensitivityAttrib():Attr("IncrSensitivity",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~IncrSensitivityAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_IncrSensitivity(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_IncrSensitivity(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_IncrSensitivity_allowed(ty);}
};

//	Attribute SyncMode class definition
class SyncModeAttrib: public Tango::Attr
{
public:
	SyncModeAttrib():Attr("SyncMode",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~SyncModeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_SyncMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_SyncMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_SyncMode_allowed(ty);}
};

//	Attribute NoiseSubtraction class definition
class NoiseSubtractionAttrib: public Tango::Attr
{
public:
	NoiseSubtractionAttrib():Attr("NoiseSubtraction",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~NoiseSubtractionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_NoiseSubtraction(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_NoiseSubtraction(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_NoiseSubtraction_allowed(ty);}
};

//	Attribute GaussFitEnable class definition
class GaussFitEnableAttrib: public Tango::Attr
{
public:
	GaussFitEnableAttrib():Attr("GaussFitEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~GaussFitEnableAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_GaussFitEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_GaussFitEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_GaussFitEnable_allowed(ty);}
};

//	Attribute FWHMEnable class definition
class FWHMEnableAttrib: public Tango::Attr
{
public:
	FWHMEnableAttrib():Attr("FWHMEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~FWHMEnableAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_FWHMEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_FWHMEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_FWHMEnable_allowed(ty);}
};

//	Attribute GaussFitCenter class definition
class GaussFitCenterAttrib: public Tango::Attr
{
public:
	GaussFitCenterAttrib():Attr("GaussFitCenter",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~GaussFitCenterAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_GaussFitCenter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_GaussFitCenter_allowed(ty);}
};

//	Attribute GaussFitWidth class definition
class GaussFitWidthAttrib: public Tango::Attr
{
public:
	GaussFitWidthAttrib():Attr("GaussFitWidth",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~GaussFitWidthAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_GaussFitWidth(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_GaussFitWidth_allowed(ty);}
};

//	Attribute FWHMCenter class definition
class FWHMCenterAttrib: public Tango::Attr
{
public:
	FWHMCenterAttrib():Attr("FWHMCenter",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~FWHMCenterAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_FWHMCenter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_FWHMCenter_allowed(ty);}
};

//	Attribute FWHMWidth class definition
class FWHMWidthAttrib: public Tango::Attr
{
public:
	FWHMWidthAttrib():Attr("FWHMWidth",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~FWHMWidthAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_FWHMWidth(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_FWHMWidth_allowed(ty);}
};

//	Attribute Center class definition
class CenterAttrib: public Tango::Attr
{
public:
	CenterAttrib():Attr("Center",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~CenterAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_Center(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_Center_allowed(ty);}
};

//	Attribute Width class definition
class WidthAttrib: public Tango::Attr
{
public:
	WidthAttrib():Attr("Width",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~WidthAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_Width(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_Width_allowed(ty);}
};

//	Attribute FitType class definition
class FitTypeAttrib: public Tango::Attr
{
public:
	FitTypeAttrib():Attr("FitType",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~FitTypeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_FitType(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_FitType(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_FitType_allowed(ty);}
};

//	Attribute FWHMAvg class definition
class FWHMAvgAttrib: public Tango::Attr
{
public:
	FWHMAvgAttrib():Attr("FWHMAvg",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~FWHMAvgAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_FWHMAvg(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_FWHMAvg(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_FWHMAvg_allowed(ty);}
};

//	Attribute NoiseLevel class definition
class NoiseLevelAttrib: public Tango::Attr
{
public:
	NoiseLevelAttrib():Attr("NoiseLevel",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~NoiseLevelAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_NoiseLevel(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_NoiseLevel(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_NoiseLevel_allowed(ty);}
};

//	Attribute DataReferenceFile class definition
class DataReferenceFileAttrib: public Tango::Attr
{
public:
	DataReferenceFileAttrib():Attr("DataReferenceFile",
			Tango::DEV_STRING, Tango::READ_WRITE) {};
	~DataReferenceFileAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_DataReferenceFile(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_DataReferenceFile(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_DataReferenceFile_allowed(ty);}
};

//	Attribute AutoExposure class definition
class AutoExposureAttrib: public Tango::Attr
{
public:
	AutoExposureAttrib():Attr("AutoExposure",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~AutoExposureAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_AutoExposure(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_AutoExposure(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_AutoExposure_allowed(ty);}
};

//	Attribute LightSourceIntensity class definition
class LightSourceIntensityAttrib: public Tango::Attr
{
public:
	LightSourceIntensityAttrib():Attr("LightSourceIntensity",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~LightSourceIntensityAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_LightSourceIntensity(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_LightSourceIntensity(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_LightSourceIntensity_allowed(ty);}
};

//	Attribute RtMode class definition
class RtModeAttrib: public Tango::Attr
{
public:
	RtModeAttrib():Attr("RtMode",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~RtModeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_RtMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_RtMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_RtMode_allowed(ty);}
};

//	Attribute LightSourceEnable class definition
class LightSourceEnableAttrib: public Tango::Attr
{
public:
	LightSourceEnableAttrib():Attr("LightSourceEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~LightSourceEnableAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_LightSourceEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_LightSourceEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_LightSourceEnable_allowed(ty);}
};

//	Attribute IntensityCalibrationEnable class definition
class IntensityCalibrationEnableAttrib: public Tango::Attr
{
public:
	IntensityCalibrationEnableAttrib():Attr("IntensityCalibrationEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~IntensityCalibrationEnableAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_IntensityCalibrationEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_IntensityCalibrationEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_IntensityCalibrationEnable_allowed(ty);}
};

//	Attribute Area class definition
class AreaAttrib: public Tango::Attr
{
public:
	AreaAttrib():Attr("Area",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~AreaAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_Area(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_Area_allowed(ty);}
};

//	Attribute AreaRegion class definition
class AreaRegionAttrib: public Tango::Attr
{
public:
	AreaRegionAttrib():Attr("AreaRegion",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~AreaRegionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_AreaRegion(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_AreaRegion(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_AreaRegion_allowed(ty);}
};

//	Attribute AreaEnable class definition
class AreaEnableAttrib: public Tango::Attr
{
public:
	AreaEnableAttrib():Attr("AreaEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~AreaEnableAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_AreaEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_AreaEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_AreaEnable_allowed(ty);}
};

//	Attribute WidhtCorrectionEnable class definition
class WidhtCorrectionEnableAttrib: public Tango::Attr
{
public:
	WidhtCorrectionEnableAttrib():Attr("WidthCorrectionEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~WidhtCorrectionEnableAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_WidhtCorrectionEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_WidhtCorrectionEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_WidhtCorrectionEnable_allowed(ty);}
};

//	Attribute NumPixels class definition
class NumPixelsAttrib: public Tango::SpectrumAttr
{
public:
	NumPixelsAttrib():SpectrumAttr("NumPixels",
			Tango::DEV_LONG, Tango::READ, 2) {};
	~NumPixelsAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_NumPixels(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_NumPixels_allowed(ty);}
};

//	Attribute Data class definition
class DataAttrib: public Tango::SpectrumAttr
{
public:
	DataAttrib():SpectrumAttr("Data",
			Tango::DEV_DOUBLE, Tango::READ, 5000) {};
	~DataAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_Data(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_Data_allowed(ty);}
};

//	Attribute RegionOfInterest class definition
class RegionOfInterestAttrib: public Tango::SpectrumAttr
{
public:
	RegionOfInterestAttrib():SpectrumAttr("RegionOfInterest",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, 2) {};
	~RegionOfInterestAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_RegionOfInterest(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_RegionOfInterest(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_RegionOfInterest_allowed(ty);}
};

//	Attribute AnalysisRegion class definition
class AnalysisRegionAttrib: public Tango::SpectrumAttr
{
public:
	AnalysisRegionAttrib():SpectrumAttr("AnalysisRegion",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, 2) {};
	~AnalysisRegionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_AnalysisRegion(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_AnalysisRegion(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_AnalysisRegion_allowed(ty);}
};

//	Attribute GaussFit class definition
class GaussFitAttrib: public Tango::SpectrumAttr
{
public:
	GaussFitAttrib():SpectrumAttr("GaussFit",
			Tango::DEV_DOUBLE, Tango::READ, 4) {};
	~GaussFitAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_GaussFit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_GaussFit_allowed(ty);}
};

//	Attribute FWHM class definition
class FWHMAttrib: public Tango::SpectrumAttr
{
public:
	FWHMAttrib():SpectrumAttr("FWHM",
			Tango::DEV_DOUBLE, Tango::READ, 3) {};
	~FWHMAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_FWHM(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_FWHM_allowed(ty);}
};

//	Attribute GaussReference class definition
class GaussReferenceAttrib: public Tango::SpectrumAttr
{
public:
	GaussReferenceAttrib():SpectrumAttr("GaussReference",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, 4) {};
	~GaussReferenceAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_GaussReference(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_GaussReference(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_GaussReference_allowed(ty);}
};

//	Attribute DataReference class definition
class DataReferenceAttrib: public Tango::SpectrumAttr
{
public:
	DataReferenceAttrib():SpectrumAttr("DataReference",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, 5000) {};
	~DataReferenceAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_DataReference(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_DataReference(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_DataReference_allowed(ty);}
};

//	Attribute IntensityCalibration class definition
class IntensityCalibrationAttrib: public Tango::SpectrumAttr
{
public:
	IntensityCalibrationAttrib():SpectrumAttr("IntensityCalibration",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, 10000) {};
	~IntensityCalibrationAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_IntensityCalibration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<OceanOptics *>(dev))->write_IntensityCalibration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_IntensityCalibration_allowed(ty);}
};

//	Attribute NoiseProfile class definition
class NoiseProfileAttrib: public Tango::SpectrumAttr
{
public:
	NoiseProfileAttrib():SpectrumAttr("NoiseProfile",
			Tango::DEV_DOUBLE, Tango::READ, 5000) {};
	~NoiseProfileAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_NoiseProfile(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_NoiseProfile_allowed(ty);}
};

//	Attribute Wave class definition
class WaveAttrib: public Tango::SpectrumAttr
{
public:
	WaveAttrib():SpectrumAttr("Wave",
			Tango::DEV_DOUBLE, Tango::READ, 5000) {};
	~WaveAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_Wave(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_Wave_allowed(ty);}
};

//	Attribute Lambda class definition
class LambdaAttrib: public Tango::SpectrumAttr
{
public:
	LambdaAttrib():SpectrumAttr("Lambda",
			Tango::DEV_DOUBLE, Tango::READ, 5000) {};
	~LambdaAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<OceanOptics *>(dev))->read_Lambda(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<OceanOptics *>(dev))->is_Lambda_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command GetVersion class definition
class GetVersionClass : public Tango::Command
{
public:
	GetVersionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetVersionClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetVersionClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_GetVersion_allowed(any);}
};

//	Command Stop class definition
class StopClass : public Tango::Command
{
public:
	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_Stop_allowed(any);}
};

//	Command StartSingle class definition
class StartSingleClass : public Tango::Command
{
public:
	StartSingleClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartSingleClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartSingleClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_StartSingle_allowed(any);}
};

//	Command StartContinuous class definition
class StartContinuousClass : public Tango::Command
{
public:
	StartContinuousClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartContinuousClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartContinuousClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_StartContinuous_allowed(any);}
};

//	Command GetLastData class definition
class GetLastDataClass : public Tango::Command
{
public:
	GetLastDataClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetLastDataClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetLastDataClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_GetLastData_allowed(any);}
};

//	Command AcquireNoise class definition
class AcquireNoiseClass : public Tango::Command
{
public:
	AcquireNoiseClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AcquireNoiseClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AcquireNoiseClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_AcquireNoise_allowed(any);}
};

//	Command SaveReferenceData class definition
class SaveReferenceDataClass : public Tango::Command
{
public:
	SaveReferenceDataClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SaveReferenceDataClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SaveReferenceDataClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_SaveReferenceData_allowed(any);}
};

//	Command OpenShutter class definition
class OpenShutterClass : public Tango::Command
{
public:
	OpenShutterClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OpenShutterClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OpenShutterClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_OpenShutter_allowed(any);}
};

//	Command CloseShutter class definition
class CloseShutterClass : public Tango::Command
{
public:
	CloseShutterClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	CloseShutterClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~CloseShutterClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_CloseShutter_allowed(any);}
};

//	Command GetData class definition
class GetDataClass : public Tango::Command
{
public:
	GetDataClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetDataClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetDataClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_GetData_allowed(any);}
};

//	Command GetGaussFitCenter class definition
class GetGaussFitCenterClass : public Tango::Command
{
public:
	GetGaussFitCenterClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetGaussFitCenterClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetGaussFitCenterClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_GetGaussFitCenter_allowed(any);}
};

//	Command GetGaussFitWidth class definition
class GetGaussFitWidthClass : public Tango::Command
{
public:
	GetGaussFitWidthClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetGaussFitWidthClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetGaussFitWidthClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_GetGaussFitWidth_allowed(any);}
};

//	Command GetFWHMCenter class definition
class GetFWHMCenterClass : public Tango::Command
{
public:
	GetFWHMCenterClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetFWHMCenterClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetFWHMCenterClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_GetFWHMCenter_allowed(any);}
};

//	Command GetFWHMWidth class definition
class GetFWHMWidthClass : public Tango::Command
{
public:
	GetFWHMWidthClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetFWHMWidthClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetFWHMWidthClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_GetFWHMWidth_allowed(any);}
};

//	Command ExportWavelength class definition
class ExportWavelengthClass : public Tango::Command
{
public:
	ExportWavelengthClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ExportWavelengthClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ExportWavelengthClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_ExportWavelength_allowed(any);}
};

//	Command GetArea class definition
class GetAreaClass : public Tango::Command
{
public:
	GetAreaClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetAreaClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetAreaClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_GetArea_allowed(any);}
};

//	Command GetWave class definition
class GetWaveClass : public Tango::Command
{
public:
	GetWaveClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetWaveClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetWaveClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_GetWave_allowed(any);}
};

//	Command GetLambda class definition
class GetLambdaClass : public Tango::Command
{
public:
	GetLambdaClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetLambdaClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetLambdaClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<OceanOptics *>(dev))->is_GetLambda_allowed(any);}
};


/**
 *	The OceanOpticsClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  OceanOpticsClass : public Tango::DeviceClass
#else
class OceanOpticsClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(OceanOpticsClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	OceanOpticsClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static OceanOpticsClass *init(const char *);
		static OceanOpticsClass *instance();
		~OceanOpticsClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		OceanOpticsClass(string &);
		static OceanOpticsClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	OceanOptics_H
