/*----- PROTECTED REGION ID(OceanOpticsStateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: OceanOpticsStateMachine.cpp,v 1.7 2019-04-23 11:16:11 graziano Exp $";
//=============================================================================
//
// file :        OceanOpticsStateMachine.cpp
//
// description : State machine file for the OceanOptics class
//
// project :     SolarLaserSystems S100
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: graziano $
//
// $Revision: 1.7 $
// $Date: 2019-04-23 11:16:11 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <OceanOptics.h>

/*----- PROTECTED REGION END -----*/	//	OceanOptics::OceanOpticsStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace OceanOptics_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_ExposureTime_allowed()
 *	Description : Execution allowed for ExposureTime attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_ExposureTime_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ExposureTime attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::ExposureTimeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::ExposureTimeStateAllowed_WRITE

	//	Not any excluded states for ExposureTime attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::ExposureTimeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::ExposureTimeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_IncrSensitivity_allowed()
 *	Description : Execution allowed for IncrSensitivity attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_IncrSensitivity_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for IncrSensitivity attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::IncrSensitivityStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::IncrSensitivityStateAllowed_WRITE

	//	Not any excluded states for IncrSensitivity attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::IncrSensitivityStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::IncrSensitivityStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_SyncMode_allowed()
 *	Description : Execution allowed for SyncMode attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_SyncMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SyncMode attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::SyncModeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::SyncModeStateAllowed_WRITE

	//	Not any excluded states for SyncMode attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::SyncModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::SyncModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_NoiseSubtraction_allowed()
 *	Description : Execution allowed for NoiseSubtraction attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_NoiseSubtraction_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for NoiseSubtraction attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::NoiseSubtractionStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::NoiseSubtractionStateAllowed_WRITE

	//	Not any excluded states for NoiseSubtraction attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::NoiseSubtractionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::NoiseSubtractionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GaussFitEnable_allowed()
 *	Description : Execution allowed for GaussFitEnable attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GaussFitEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for GaussFitEnable attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::GaussFitEnableStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GaussFitEnableStateAllowed_WRITE

	//	Not any excluded states for GaussFitEnable attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::GaussFitEnableStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GaussFitEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_FWHMEnable_allowed()
 *	Description : Execution allowed for FWHMEnable attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_FWHMEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for FWHMEnable attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::FWHMEnableStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::FWHMEnableStateAllowed_WRITE

	//	Not any excluded states for FWHMEnable attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::FWHMEnableStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::FWHMEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GaussFitCenter_allowed()
 *	Description : Execution allowed for GaussFitCenter attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GaussFitCenter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for GaussFitCenter attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::GaussFitCenterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GaussFitCenterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GaussFitWidth_allowed()
 *	Description : Execution allowed for GaussFitWidth attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GaussFitWidth_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for GaussFitWidth attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::GaussFitWidthStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GaussFitWidthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_FWHMCenter_allowed()
 *	Description : Execution allowed for FWHMCenter attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_FWHMCenter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FWHMCenter attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::FWHMCenterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::FWHMCenterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_FWHMWidth_allowed()
 *	Description : Execution allowed for FWHMWidth attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_FWHMWidth_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FWHMWidth attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::FWHMWidthStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::FWHMWidthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_Center_allowed()
 *	Description : Execution allowed for Center attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_Center_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Center attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::CenterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::CenterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_Width_allowed()
 *	Description : Execution allowed for Width attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_Width_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Width attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::WidthStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::WidthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_FitType_allowed()
 *	Description : Execution allowed for FitType attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_FitType_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for FitType attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::FitTypeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::FitTypeStateAllowed_WRITE

	//	Not any excluded states for FitType attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::FitTypeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::FitTypeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_FWHMAvg_allowed()
 *	Description : Execution allowed for FWHMAvg attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_FWHMAvg_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for FWHMAvg attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::FWHMAvgStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::FWHMAvgStateAllowed_WRITE

	//	Not any excluded states for FWHMAvg attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::FWHMAvgStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::FWHMAvgStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_NoiseLevel_allowed()
 *	Description : Execution allowed for NoiseLevel attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_NoiseLevel_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for NoiseLevel attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::NoiseLevelStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::NoiseLevelStateAllowed_WRITE

	//	Not any excluded states for NoiseLevel attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::NoiseLevelStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::NoiseLevelStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_DataReferenceFile_allowed()
 *	Description : Execution allowed for DataReferenceFile attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_DataReferenceFile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DataReferenceFile attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::DataReferenceFileStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::DataReferenceFileStateAllowed_WRITE

	//	Not any excluded states for DataReferenceFile attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::DataReferenceFileStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::DataReferenceFileStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_AutoExposure_allowed()
 *	Description : Execution allowed for AutoExposure attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_AutoExposure_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoExposure attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::AutoExposureStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::AutoExposureStateAllowed_WRITE

	//	Not any excluded states for AutoExposure attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::AutoExposureStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::AutoExposureStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_LightSourceIntensity_allowed()
 *	Description : Execution allowed for LightSourceIntensity attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_LightSourceIntensity_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for LightSourceIntensity attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::LightSourceIntensityStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::LightSourceIntensityStateAllowed_WRITE

	//	Not any excluded states for LightSourceIntensity attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::LightSourceIntensityStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::LightSourceIntensityStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_RtMode_allowed()
 *	Description : Execution allowed for RtMode attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_RtMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for RtMode attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::RtModeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::RtModeStateAllowed_WRITE

	//	Not any excluded states for RtMode attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::RtModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::RtModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_LightSourceEnable_allowed()
 *	Description : Execution allowed for LightSourceEnable attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_LightSourceEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for LightSourceEnable attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::LightSourceEnableStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::LightSourceEnableStateAllowed_WRITE

	//	Not any excluded states for LightSourceEnable attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::LightSourceEnableStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::LightSourceEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_IntensityCalibrationEnable_allowed()
 *	Description : Execution allowed for IntensityCalibrationEnable attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_IntensityCalibrationEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for IntensityCalibrationEnable attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::IntensityCalibrationEnableStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::IntensityCalibrationEnableStateAllowed_WRITE

	//	Not any excluded states for IntensityCalibrationEnable attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::IntensityCalibrationEnableStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::IntensityCalibrationEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_Area_allowed()
 *	Description : Execution allowed for Area attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_Area_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Area attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::AreaStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::AreaStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_AreaRegion_allowed()
 *	Description : Execution allowed for AreaRegion attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_AreaRegion_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AreaRegion attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::AreaRegionStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::AreaRegionStateAllowed_WRITE

	//	Not any excluded states for AreaRegion attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::AreaRegionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::AreaRegionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_AreaEnable_allowed()
 *	Description : Execution allowed for AreaEnable attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_AreaEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AreaEnable attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::AreaEnableStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::AreaEnableStateAllowed_WRITE

	//	Not any excluded states for AreaEnable attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::AreaEnableStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::AreaEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_WidhtCorrectionEnable_allowed()
 *	Description : Execution allowed for WidhtCorrectionEnable attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_WidhtCorrectionEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for WidhtCorrectionEnable attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::WidhtCorrectionEnableStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::WidhtCorrectionEnableStateAllowed_WRITE

	//	Not any excluded states for WidhtCorrectionEnable attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::WidhtCorrectionEnableStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::WidhtCorrectionEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_NumPixels_allowed()
 *	Description : Execution allowed for NumPixels attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_NumPixels_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for NumPixels attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::NumPixelsStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::NumPixelsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_Data_allowed()
 *	Description : Execution allowed for Data attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_Data_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Data attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::DataStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::DataStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_RegionOfInterest_allowed()
 *	Description : Execution allowed for RegionOfInterest attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_RegionOfInterest_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for RegionOfInterest attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::RegionOfInterestStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::RegionOfInterestStateAllowed_WRITE

	//	Not any excluded states for RegionOfInterest attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::RegionOfInterestStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::RegionOfInterestStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_AnalysisRegion_allowed()
 *	Description : Execution allowed for AnalysisRegion attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_AnalysisRegion_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AnalysisRegion attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::AnalysisRegionStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::AnalysisRegionStateAllowed_WRITE

	//	Not any excluded states for AnalysisRegion attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::AnalysisRegionStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::AnalysisRegionStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GaussFit_allowed()
 *	Description : Execution allowed for GaussFit attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GaussFit_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for GaussFit attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::GaussFitStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GaussFitStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_FWHM_allowed()
 *	Description : Execution allowed for FWHM attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_FWHM_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FWHM attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::FWHMStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::FWHMStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GaussReference_allowed()
 *	Description : Execution allowed for GaussReference attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GaussReference_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for GaussReference attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::GaussReferenceStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GaussReferenceStateAllowed_WRITE

	//	Not any excluded states for GaussReference attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::GaussReferenceStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GaussReferenceStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_DataReference_allowed()
 *	Description : Execution allowed for DataReference attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_DataReference_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DataReference attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::DataReferenceStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::DataReferenceStateAllowed_WRITE

	//	Not any excluded states for DataReference attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::DataReferenceStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::DataReferenceStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_IntensityCalibration_allowed()
 *	Description : Execution allowed for IntensityCalibration attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_IntensityCalibration_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for IntensityCalibration attribute in Write access.
	/*----- PROTECTED REGION ID(OceanOptics::IntensityCalibrationStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::IntensityCalibrationStateAllowed_WRITE

	//	Not any excluded states for IntensityCalibration attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::IntensityCalibrationStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::IntensityCalibrationStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_NoiseProfile_allowed()
 *	Description : Execution allowed for NoiseProfile attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_NoiseProfile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for NoiseProfile attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::NoiseProfileStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::NoiseProfileStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_Wave_allowed()
 *	Description : Execution allowed for Wave attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_Wave_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Wave attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::WaveStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::WaveStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_Lambda_allowed()
 *	Description : Execution allowed for Lambda attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_Lambda_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Lambda attribute in read access.
	/*----- PROTECTED REGION ID(OceanOptics::LambdaStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::LambdaStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GetVersion_allowed()
 *	Description : Execution allowed for GetVersion attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GetVersion_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetVersion command.
	/*----- PROTECTED REGION ID(OceanOptics::GetVersionStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GetVersionStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_Stop_allowed()
 *	Description : Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Stop command.
	/*----- PROTECTED REGION ID(OceanOptics::StopStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::StopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_StartSingle_allowed()
 *	Description : Execution allowed for StartSingle attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_StartSingle_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for StartSingle command.
	/*----- PROTECTED REGION ID(OceanOptics::StartSingleStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::StartSingleStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_StartContinuous_allowed()
 *	Description : Execution allowed for StartContinuous attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_StartContinuous_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for StartContinuous command.
	/*----- PROTECTED REGION ID(OceanOptics::StartContinuousStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::StartContinuousStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GetLastData_allowed()
 *	Description : Execution allowed for GetLastData attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GetLastData_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetLastData command.
	/*----- PROTECTED REGION ID(OceanOptics::GetLastDataStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GetLastDataStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_AcquireNoise_allowed()
 *	Description : Execution allowed for AcquireNoise attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_AcquireNoise_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for AcquireNoise command.
	/*----- PROTECTED REGION ID(OceanOptics::AcquireNoiseStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::AcquireNoiseStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_SaveReferenceData_allowed()
 *	Description : Execution allowed for SaveReferenceData attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_SaveReferenceData_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SaveReferenceData command.
	/*----- PROTECTED REGION ID(OceanOptics::SaveReferenceDataStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::SaveReferenceDataStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_OpenShutter_allowed()
 *	Description : Execution allowed for OpenShutter attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_OpenShutter_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for OpenShutter command.
	/*----- PROTECTED REGION ID(OceanOptics::OpenShutterStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::OpenShutterStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_CloseShutter_allowed()
 *	Description : Execution allowed for CloseShutter attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_CloseShutter_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for CloseShutter command.
	/*----- PROTECTED REGION ID(OceanOptics::CloseShutterStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::CloseShutterStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GetData_allowed()
 *	Description : Execution allowed for GetData attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GetData_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetData command.
	/*----- PROTECTED REGION ID(OceanOptics::GetDataStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GetDataStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GetGaussFitCenter_allowed()
 *	Description : Execution allowed for GetGaussFitCenter attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GetGaussFitCenter_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetGaussFitCenter command.
	/*----- PROTECTED REGION ID(OceanOptics::GetGaussFitCenterStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GetGaussFitCenterStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GetGaussFitWidth_allowed()
 *	Description : Execution allowed for GetGaussFitWidth attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GetGaussFitWidth_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetGaussFitWidth command.
	/*----- PROTECTED REGION ID(OceanOptics::GetGaussFitWidthStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GetGaussFitWidthStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GetFWHMCenter_allowed()
 *	Description : Execution allowed for GetFWHMCenter attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GetFWHMCenter_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetFWHMCenter command.
	/*----- PROTECTED REGION ID(OceanOptics::GetFWHMCenterStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GetFWHMCenterStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GetFWHMWidth_allowed()
 *	Description : Execution allowed for GetFWHMWidth attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GetFWHMWidth_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetFWHMWidth command.
	/*----- PROTECTED REGION ID(OceanOptics::GetFWHMWidthStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GetFWHMWidthStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_ExportWavelength_allowed()
 *	Description : Execution allowed for ExportWavelength attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_ExportWavelength_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ExportWavelength command.
	/*----- PROTECTED REGION ID(OceanOptics::ExportWavelengthStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::ExportWavelengthStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GetArea_allowed()
 *	Description : Execution allowed for GetArea attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GetArea_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetArea command.
	/*----- PROTECTED REGION ID(OceanOptics::GetAreaStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GetAreaStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GetWave_allowed()
 *	Description : Execution allowed for GetWave attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GetWave_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetWave command.
	/*----- PROTECTED REGION ID(OceanOptics::GetWaveStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GetWaveStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : OceanOptics::is_GetLambda_allowed()
 *	Description : Execution allowed for GetLambda attribute
 */
//--------------------------------------------------------
bool OceanOptics::is_GetLambda_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetLambda command.
	/*----- PROTECTED REGION ID(OceanOptics::GetLambdaStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	OceanOptics::GetLambdaStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(OceanOptics::OceanOpticsStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	OceanOptics::OceanOpticsStateAllowed.AdditionalMethods

}	//	End of namespace
