//
// file :         readthread.h
//
// description :  reading thread
//
// project :      TANGO Device Server
//
// $Author: graziano $ 
//
// $Revision: 1.1 $
//
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
//

#ifndef READTHREAD_H_
#define READTHREAD_H_

#include <tango.h>
#include <omnithread.h>
#include "OceanOptics.h"
//#include "UsbCDD.h"

class readthread : public omni_thread, public Tango::LogAdapter 
{	
	private:
		OceanOptics_ns::OceanOptics *mysolar;
		
		void abort_sleep(double time);
		int wait_counter;
		bool use_last_fit;
		unsigned long old_bunch_number;
		bool just_reconnected;
				
	public:
		
		readthread(OceanOptics_ns::OceanOptics *s);
		~readthread();
		
		omni_mutex *mutex_sleep;		
		int pausesec,pausenano;
		double min_fit_time;
		double max_fit_time;
		double tot_fit_time;
		double avg_fit_time;
		size_t fit_counter;
					
	protected:
		void run(void *);
		
};	/* end class readthread() */

#endif /*READTHREAD_H_*/
